require("technology")

data:extend(
{
    {
        type = "fuel-category",
        name = "battery"
    },
    {
        type = "item-group",
        name = "hexi-battery",
        order = "g",
        icon = "__base__/graphics/item-group/signals.png"
    },
    {
        type = "item-subgroup",
        name = "hexi-battery",
        group = "hexi-battery",
        order = "a"
    },
    {
        type = "recipe-category",
        name = "hexi-battery-charging"
    },
    {
        type = "recipe",
        name = "hexi-battery",
        enabled = false,
        energy_required = 5,
        ingredients = {{"battery", 20}, {"steel-plate", 5}, {"advanced-circuit", 2}},
        results = {{"hexi-empty-battery", 1}}
    },
    {
        type = "recipe",
        name = "hexi-battery-charging",
        category = "hexi-battery-charging",
        enabled = false,
        energy_required = 10,
        ingredients = {{"hexi-empty-battery", 1}},
        results = {{"hexi-charged-battery", 1}}
    },
    {
        type = "item",
        name = "hexi-empty-battery",
        icon = "__Hexi_Recharging_Batteries__/graphics/battery_empty.png",
        flags = {"goes-to-main-inventory"},
        subgroup = "hexi-battery",
        order = "b[battery]-a",
        fuel_category = "battery",
        burnt_result = "battery",
        stack_size = 5
    },
    {
        type = "item",
        name = "hexi-charged-battery",
        icon = "__Hexi_Recharging_Batteries__/graphics/battery_full.png",
        flags = {"goes-to-main-inventory"},
        subgroup = "hexi-battery",
        order = "b[battery]-b",
        fuel_category = "battery",
        burnt_result = "hexi-empty-battery",
        fuel_value = "20MJ",
        stack_size = 5
    },
    {
        type = "recipe",
        name = "hexi-battery-charger",
        enabled = false,
        energy_required = 3.5,
        ingredients = {{"electronic-circuit", 5}, {"iron-gear-wheel", 10}, {"iron-plate", 20}},
        result = "hexi-battery-charging-building",
        result_count = 1
    },
    {
        type = "item",
        name = "hexi-battery-charging-building",
        icon = "__Hexi_Recharging_Batteries__/graphics/charger-icon.png",
        flags = {"goes-to-quickbar"},
        subgroup = "hexi-battery",
        order = "a[charger]-a",
        place_result = "hexi-battery-charging-building",
        stack_size = 50
    },
    {
        type = "assembling-machine",
        fixed_recipe = "hexi-battery-charging",
        ingredient_count = 1,
        result_count = 1,
        name = "hexi-battery-charging-building",
        icon = "__Hexi_Recharging_Batteries__/graphics/charger-icon.png",
        flags = {"placeable-neutral", "placeable-player", "player-creation"},
        minable = {mining_time = 1, result = "hexi-battery-charging-building"},
        max_health = 150,
        corpse = "big-remnants",
        dying_explosion = "medium-explosion",
        light = {intensity = 1, size = 10},
        resistances =
        {
            {
                type = "fire",
                percent = 80
            }
        },
        collision_box = {{-2.8, -1.8}, {2.8, 1.8}},
        selection_box = {{-3, -2}, {3, 2}}, --Should be {{-3, -2}, {3, 2}} but the selection box does not rotate, so for now it's incorrect but square.
        crafting_categories = {"hexi-battery-charging"},
        result_inventory_size = 1,
        crafting_speed = 1,
        energy_usage = "2MW",
        energy_source =
        {
            type = "electric",
            usage_priority = "secondary-input",
            drain = "0W"
        },
        vehicle_impact_sound = { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
        working_sound =
        {
            sound =
            {
                filename = "__base__/sound/electric-furnace.ogg",
                volume = 0.7
            },
            apparent_volume = 1.5
        },
        animation = {
            north = {
                filename = "__Hexi_Recharging_Batteries__/graphics/charger.png",
                priority = "high",
                width = 512,
                height = 384,
                scale = 0.5,
                frame_count = 1
            },
            east = {
                filename = "__Hexi_Recharging_Batteries__/graphics/charger.png",
                priority = "high",
                width = 512,
                height = 384,
                y = 384,
                scale = 0.5,
                frame_count = 1
            }
        },
        fluid_boxes = {} --Tricks the assembler into using rotation sprites.
    },
    --[[{
        type = "recipe",
        name = "hexi-battery-discharger",
        enabled = false,
        energy_required = 3.5,
        ingredients = {{"electronic-circuit", 5}, {"iron-gear-wheel", 10}, {"iron-plate", 20}},
        result = "hexi-battery-discharging-building",
        result_count = 1
    },
    {
        type = "item",
        name = "hexi-battery-discharging-building",
        icon = "__Hexi_Recharging_Batteries__/graphics/discharger-icon.png",
        flags = {"goes-to-quickbar"},
        subgroup = "hexi-battery",
        order = "a[charger]-b",
        place_result = "hexi-battery-discharging-building",
        stack_size = 50
    },
    {
        type = "simple-generator",
        name = "hexi-battery-discharging-building",
        icon = "__Hexi_Recharging_Batteries__/graphics/discharger-icon.png",
        flags = {"placeable-neutral", "placeable-player", "player-creation"},
        minable = {mining_time = 1, result = "hexi-battery-discharger"},
        max_health = 400,
        corpse = "big-remnants",
        resistances =
        {
            {
                type = "fire",
                percent = 70
            },
            {
                type = "impact",
                percent = 30
            }
        },
        collision_box = {{-.8, -.8}, {.8, .8}},
        selection_box = {{-1, -1}, {1, 1}},
        energy_usage = "2MW",
        energy_source =
        {
            type = "burner",
            fuel_category = "battery",
            fuel_inventory_size = 1,
            burnt_inventory_size = 1,
            usage_priority = "secondary-output"
        },
        animation =
        {
            filename = "__Hexi_Recharging_Batteries__/graphics/discharger.png",
            priority = "high",
            width = 256,
            height = 128,
            scale = 0.5,
            shift = {0, 0},
            frame_count = 1,
            line_length = 5,
            animation_speed = 0.5
        }
        vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
        min_perceived_performance = 0.25
    },]]
    {
        type = "recipe",
        name = "hexi-battery-boiler",
        enabled = false,
        energy_required = 3.5,
        ingredients = {{"electronic-circuit", 5}, {"iron-gear-wheel", 10}, {"iron-plate", 20}},
        result = "hexi-battery-boiler",
        result_count = 1
    },
    {
        type = "item",
        name = "hexi-battery-boiler",
        icon = "__base__/graphics/icons/boiler.png",
        flags = {"goes-to-quickbar"},
        subgroup = "hexi-battery",
        order = "a[charger]-c",
        place_result = "hexi-battery-boiler",
        stack_size = 50
    },
    {
        type = "boiler",
        name = "hexi-battery-boiler",
        icon = "__base__/graphics/icons/boiler.png",
        flags = {"placeable-neutral", "player-creation"},
        minable = {hardness = 0.2, mining_time = 0.5, result = "hexi-battery-boiler"},
        max_health = 200,
        corpse = "small-remnants",
        vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
        mode = "output-to-separate-pipe",
        resistances =
        {
            {
                type = "fire",
                percent = 90
            },
            {
                type = "explosion",
                percent = 30
            },
            {
                type = "impact",
                percent = 30
            }
        },
        collision_box = {{-1.29, -0.79}, {1.29, 0.79}},
        selection_box = {{-1.5, -1}, {1.5, 1}},
        target_temperature = 165,
        fluid_box =
        {
            base_area = 1,
            height = 2,
            base_level = -1,
            pipe_covers = pipecoverspictures(),
            pipe_connections =
            {
                {type = "input-output", position = {-2, 0.5}},
                {type = "input-output", position = {2, 0.5}}
            },
            production_type = "input-output"
        },
        output_fluid_box =
        {
            base_area = 1,
            height = 2,
            base_level = 1,
            pipe_covers = pipecoverspictures(),
            pipe_connections = {{type = "output", position = {0, -1.5}}},
            production_type = "output"
        },
        fluid_input =
        {
            name = "water",
            amount = 0.0
        },
        fluid_output =
        {
            name = "steam",
            amount = 0.0
        },
        energy_consumption = "1.8MW",
        energy_source =
        {
            type = "burner",
            fuel_category = "battery",
            fuel_inventory_size = 1,
            burnt_inventory_size = 1
        },
        structure = data.raw.boiler.boiler.structure,
        patch = data.raw.boiler.boiler.patch,
        fire_flicker_enabled = true,
        fire = data.raw.boiler.boiler.fire,
        fire_glow_flicker_enabled = true,
        fire_glow = data.raw.boiler.boiler.fire_glow,
        burning_cooldown = 20
    },
})